define(["require", "exports", "./provide_when_on_syntax", "./provide_when_syntax", "./provide_on_syntax", "./provide_done_syntax"], function (require, exports, provide_when_on_syntax_1, provide_when_syntax_1, provide_on_syntax_1, provide_done_syntax_1) {
    "use strict";
    var ProvideInSyntax = (function () {
        function ProvideInSyntax(bindingInSyntax, provideDoneSyntax) {
            this._bindingInSyntax = bindingInSyntax;
            this._provideDoneSyntax = provideDoneSyntax;
        }
        ProvideInSyntax.prototype.inSingletonScope = function () {
            var bindingWhenOnSyntax = this._bindingInSyntax.inSingletonScope();
            var provideWhenSyntax = new provide_when_syntax_1.default(bindingWhenOnSyntax, this._provideDoneSyntax);
            var provideOnSyntax = new provide_on_syntax_1.default(bindingWhenOnSyntax, this._provideDoneSyntax);
            return new provide_when_on_syntax_1.default(provideWhenSyntax, provideOnSyntax);
        };
        ProvideInSyntax.prototype.inTransientScope = function () {
            var bindingWhenOnSyntax = this._bindingInSyntax.inTransientScope();
            var provideWhenSyntax = new provide_when_syntax_1.default(bindingWhenOnSyntax, this._provideDoneSyntax);
            var provideOnSyntax = new provide_on_syntax_1.default(bindingWhenOnSyntax, this._provideDoneSyntax);
            return new provide_when_on_syntax_1.default(provideWhenSyntax, provideOnSyntax);
        };
        ProvideInSyntax.prototype.done = function () {
            var binding = this._bindingInSyntax._binding;
            var provideDoneSyntax = new provide_done_syntax_1.default(binding);
            return provideDoneSyntax.done();
        };
        return ProvideInSyntax;
    }());
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.default = ProvideInSyntax;
});
